<template>
  <div class="container">
    <div class="columns">
      <div class="column package-section top-actions">
        <div class="columns">
          <div class="col-12" v-if="alertSuccess">
            <div class="toast toast-primary">
              <button class="btn btn-clear float-right"></button>
              <p>Package submitted successfully</p>
            </div>
          </div>
        </div>
        <div class="columns">
          <div class="col-6">
          </div>
          <div class="col-6 space1">
            <a class="btn btn-package" href="#packageModal" @click="showPackages">Use Template</a>
            <!-- <button class="btn btn-package" @click="addRow">Add Earnings</button> -->
            <button class="btn btn-package float-right space045" @click="savePackage" v-show="earningsExist">Submit Package</button>
          </div>

        </div> 
      </div>
    </div>
    <div class="columns">
      <div class="column package-section">
        
        <div class="columns earning_space">
          <div class="column col-6">
            <span class="profile_tab" v-bind:class="{highlight: currentTab}" @click="current">Earnings</span><span class="pipe">|</span>
            <span class="account_tab" v-bind:class="{highlight: deductionTab}" @click="deductionView">Deductions</span>
          </div>
          <div class="column col-6 space-1">
            <span class="current"><input type="radio" name="earnings" value="current" class="radio" v-on:focus="currentEarning">Current</span>
         
            <input type="radio" name="earnings" value="history" class="radio" v-on:focus="historyEarning">History
          </div>
        </div>
        <div v-if="currentTab">             
          <table class="table">
            <thead>
              <tr>
                <th>
                  <input type="checkbox" />
                </th>
                <th>Type</th>
                <th>Rate</th>
                <th>Start</th>
                <th>End</th>
                <th>Frequency</th>
                <th>Basis</th>
                <th></th>
              </tr>
            </thead>
            <tbody ref="editable_table" v-if="earningsExist">
              <tr v-for="(e, index) in earnings" v-bind:key="index">
                <td>
                  <input type="checkbox" />
                </td>
                <td>
                  <span v-if="e.is_editable">
                    <select class="custom-form-select" v-model="earning.type">
                      <option value="">Choose type</option>
                      <option v-for="type in types" v-bind:key="type">{{ type }}</option>
                    </select>
                  </span>
                  <span v-else>{{ e.type }}</span>
                </td>
                <td>
                  <div v-if="e.is_editable">
                    <input class="form-input" type="number" v-model="earning.rate" />
                  </div>
                  <span v-else>{{ formatNumber(e.rate) }}</span>
                </td>               
                <td v-if="!e.is_editable">{{ e.startDate }}</td>
                <td v-if="!e.is_editable">{{ e.endDate }}</td>
                <td v-if="e.is_editable" colspan="2" id="inline_datepicker">
                  <el-date-picker 
                      v-model="dates"
                      type="daterange"
                      start-placeholder="Start date"
                      end-placeholder="End date"
                      value-format="yyyy-MM-dd"
                      >
                    </el-date-picker>
                </td>
                    <!-- 
                <td>
                  <div v-if="e.is_editable">
                    <input class="form-input date_context" type="date" value="2016-12-31" v-model="earning.startDate" />
                  </div>
                  <span v-else>{{ e.startDate }}</span>
                </td>
                <td>
                  <div v-if="e.is_editable">
                    <input class="form-input date_context" type="date" value="2016-12-31" v-model="earning.endDate" />
                  </div>
                  <span v-else>{{ e.endDate }}</span>
                </td> -->



                <td>
                  <div v-if="e.is_editable">
                    <select class="custom-form-select" v-model="earning.frequency">
                      <option v-for="frequency in frequencies" v-bind:key="frequency">{{frequency}}</option>
                    </select>
                  </div>
                  <span v-else>{{ e.frequency }}</span>
                </td>
                <td>
                  <div v-if="e.is_editable">
                    <select class="custom-form-select" v-model="earning.basis">
                      <option value="">Choose basis</option>
                      <option v-for="base in basis" v-bind:key="base">{{ base }}</option>
                    </select>
                  </div>
                  <span v-else>{{ e.basis }}</span>
                </td>
                <td>
                  <div v-if="e.is_editable" >
                    <span  @click="addItem(index)"><img src="images/icons/content-save.svg" alt="Save icon" class="table_icon"/></span> |
                    <span  @click="cancelItem(index)"><img src="images/icons/close-circle.svg" alt="Cancel icon" class="table_icon "/></span>
                  </div>
                  <div v-else>
                    <span @click="editRow(index)"><img src="images/icons/pencil-outline.svg" alt="Edit icon" class="table_icon"/></span> |
                    <span @click="deleteRow(index)"><img src="images/icons/delete-outline.svg" alt="Delete icon" class="table_icon"/></span>
                  </div>
                </td>
              </tr>
            </tbody>
            <tbody ref="editable_table" v-else>
              <tr>
                <td class="empty-earnings" colspan="7">No data</td>
              </tr>
            </tbody>
          </table>
          <div class="columns">
            <div class="column package-section">
              <div class="float-right btm-actions">
                <span class="newBtn float-right" @click="addRow"><img src="/images/icons/show_page_add.svg" alt="edit icon" class=""/><span class="icon_label">ADD</span></span>
                <!-- <button class="btn btn-package" @click="savePackage" v-show="earningsExist">Submit Package</button> -->
              </div>
            </div>
          </div>
        </div>

        <div v-if="historyTab">             
          <table class="table">
            <thead>
              <tr>
                <th>Rate</th>
                <th>Start</th>
                <th>End</th>
                <th>Frequency</th>
                <th>Basis</th>
                <th></th>
              </tr>
            </thead>
            <tbody ref="editable_table" v-if="earningsExist">
              <tr v-for="(e, index) in allEarnings" v-bind:key="index">
                <td>
                  <span v-if="e.is_editable">
                    <select class="custom-form-select" v-model="earning.type">
                      <option value="">Choose type</option>
                      <option v-for="type in types" v-bind:key="type">{{ type }}</option>
                    </select>
                  </span>
                  <span v-else>{{ e.type }}</span>
                </td>
                <td>
                  <div v-if="e.is_editable">
                    <input class="form-input" type="number" v-model="earning.rate" />
                  </div>
                  <span v-else>{{ formatNumber(e.rate) }}</span>
                </td>               
                <td v-if="!e.is_editable">{{ e.startDate }}</td>
                <td v-if="!e.is_editable">{{ e.endDate }}</td>
                <td v-if="e.is_editable" colspan="2" id="inline_datepicker">
                  <el-date-picker 
                      v-model="dates"
                      type="daterange"
                      start-placeholder="Start date"
                      end-placeholder="End date"
                      value-format="yyyy-MM-dd"
                      >
                    </el-date-picker>
                </td>
                <td>
                  {{ e.frequency }}
                </td>
                <td>
                  {{ e.basis }}
                </td>
              </tr>
            </tbody>
            <tbody ref="editable_table" v-else>
              <tr>
                <td class="empty-earnings" colspan="7">No data</td>
              </tr>
            </tbody>
          </table>
          <div class="columns">
            <div class="column package-section">
              <div class="float-right btm-actions">
                <span class="newBtn float-right" @click="addRow"><img src="/images/icons/show_page_add.svg" alt="edit icon" class=""/><span class="icon_label">ADD</span></span>
                <!-- <button class="btn btn-package" @click="savePackage" v-show="earningsExist">Submit Package</button> -->
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    
    <div class="columns deduction" v-if="deductionTab">
      <!-- <div class="column col-12 space045">
        <h6>Gross Pay = {{ formatNumber(grossPay) }}</h6>
      </div> -->
      <!-- <div class="column col-12">
        <table class="table table-striped">
          <thead>
            <tr><th colspan="2"><strong>Deductions</strong></th></tr>
            <tr>
              <td>Type</td>
              <td>Amount</td>
            </tr>
          </thead>
          <tbody>
            <tr>
              <td>Tax</td><td>{{ formatNumber(tax, true) }}</td>
            </tr>
            <tr>
              <td>Pension</td><td>{{ formatNumber(pension, true) }}</td>
            </tr>
            <tr>
              <td>HMO</td><td>{{ formatNumber(hmo/12, true) }}</td>
            </tr>
            <tr>
              <td>NHF</td><td>{{ formatNumber(nhf, true) }}</td>
            </tr>
            <tr>
              <td colspan="2"><h6>Total Deductions = {{ formatNumber(totalDeduction, true) }}</h6></td>
            </tr>
          </tbody>
        </table>
      </div> -->



      <div class="column col-12">
        
          <table class="table">
            <thead>
              <tr>
                <th>Type</th>
                <th>Start</th>
                <th>End</th>
                <th>Frequency</th>
                <th>Basis</th>
                <th>Rate</th>
                <th></th>
              </tr>
            </thead>
            <tbody ref="editable_table">
              <tr v-for="(d, index) in deductions" v-bind:key="index">
                <td>
                  <span v-if="d.is_editable">
                    <select class="form-select" v-model="deduction.type">
                      <option value="">Choose type</option>
                      <option v-for="deductionType in deductionTypes" v-bind:key="deductionType">{{ deductionType }}</option>
                    </select>
                  </span>
                  <span v-else>{{ d.type }}</span>
                </td>
               
                <td>
                  <div v-if="d.is_editable">
                    <input class="form-input date_context" type="date" value="2016-12-31" v-model="deduction.startDate" />
                  </div>
                  <span v-else>{{ d.start_date }}</span>
                </td>
                <td>
                  <div v-if="d.is_editable">
                    <input class="form-input date_context" type="date" value="2016-12-31" v-model="deduction.endDate" />
                  </div>
                  <span v-else>{{ d.end_date }}</span>
                </td>

                
                <td>
                  <span v-if="d.is_editable">
                    <select class="form-select" v-model="deduction.frequency">
                      <option value="">Choose frequency</option>
                      <option v-for="frequency in frequencies" v-bind:key="frequency">{{frequency}}</option>
                    </select>
                  </span>
                  <span v-else>{{ d.frequency }}</span>
                </td>
                <td>
                  <span v-if="d.is_editable">
                    <select class="form-select" v-model="deduction.basis">
                      <option value="">Choose basis</option>
                      <option v-for="base in basis" v-bind:key="base">{{ base }}</option>
                    </select>
                  </span>
                  <span v-else>{{ d.basis }}</span>
                </td>
                <td>
                  <span v-if="d.is_editable">
                    <input class="form-input" type="number" v-model="deduction.rate"/>
                  </span>
                  <span v-else>- {{ d.rate }}</span>
                </td>
                <td>
                  <span v-if="d.is_editable">
                    <span @click="addDeductionItem(index)"><img src="/images/icons/content-save.svg" alt="Save icon" class="table_icon"/></span> |
                    <span @click="cancelDeductionItem(index)"><img src="/images/icons/close-circle.svg" alt="Cancel icon" class="table_icon"/></span>
                  </span>
                  <div v-else>
                    <span @click="editDeductionRow(index)"><img src="/images/icons/pencil-outline.svg" alt="Edit icon" class="table_icon"/></span> |
                    <span @click="deleteRow(index)"><img src="/images/icons/delete-outline.svg" alt="Delete icon" class="table_icon"/></span>
                  </div>
                </td>
              </tr>
            </tbody>
          </table>
          <br>
          <span class="newBtn float-right" @click="addDeductionRow"><img src="/images/icons/show_page_add.svg" alt="edit icon" class=""/><span class="icon_label">ADD</span></span>
        
      </div>
    </div>

    <div class="column">
      <div class="modal" id="packageModal">
        <a class="modal-overlay" href="#modals" aria-label="Close"></a>
        <div class="modal-container modal-fullheight packageModal" role="document">
          <div class="modal-header">
            <a class="btn btn-clear float-right modalclosebtn" href="#modals" aria-label="Close"></a>
            <div class="modal-title h5 modalTitle">Package Templates</div>
          </div>
          <div class="modal-body">
            <div class="content">   
              <div>Start Date <span class="range-divider">-</span> End Date</div>
               <div class="columns">                
                <div class="column col-6" id="inline_datepicker2">               
                  <el-date-picker
                      v-model="dates2"
                      type="daterange"
                      start-placeholder="Start date"
                      end-placeholder="End date"
                      value-format="yyyy-MM-dd"
                      >
                    </el-date-picker>
                </div>   
              </div>            
              <!-- <div class="columns space14">
                
                  <div class="column col-3 space14">                      
                      <label>Start Date</label><br>
                      <input class="startDate" type="date" v-model="startDate" />                      
                  </div>

                  <div class="column col-3 space14">                    
                      <label>End Date</label><br>  
                      <input class="endDate" type="date" v-model="endDate" />
                  </div>
                </div> -->
              <div class="columns">
                <!-- <div class="column col-6 "> -->
                  

                <!-- </div> -->
                <div class="column col-6">
                  <div class="input-group">
                    <select v-model="package_id" name="package" class="form-select select-sm" v-on:change="getPackageEarnings" value="Select Package">
                      <option selected="selected">Select Package</option>
                      <option
                        v-for="employeePackage in employeePackages"
                        v-bind:value="employeePackage.id"
                        :key="employeePackage.id"
                      >{{ employeePackage.tag }} - {{ employeePackage.description }}</option>
                    </select>
                  </div>
                </div>
                <div class="column col-12" v-if="t_earnings">
                  <div class="t_space">
                    <table class="table table-striped table-hover">
                      <thead>
                        <tr>
                          <th>Type</th>
                          <th>Frequency</th>
                          <th>Basis</th>
                          <th>Rate</th>
                        </tr>
                      </thead>
                      <tbody>
                        <tr v-for="item in packageEarnings" v-bind:key="item.id">
                          <td>{{ item.type }}</td>
                          <td>{{ item.frequency }}</td>
                          <td>{{ item.basis }}</td>
                          <td>{{ formatNumber(item.rate) }}</td>
                        </tr>
                      </tbody>
                    </table>
                  </div>
                   <div class="columns t_space">
                    <div class="column col-6">
                      <input type="checkbox" id="checkbox" v-model="checked">
                      <label for="checkbox">Add to Existing Earnings</label>
                    </div>
                    
                  </div><br>
                  <div class="columns">
                    <div class="column col-6">
                      <div class="column col6 adjust_margin_left edit_group newBtn" @click="applyPackage"><img src="images/icons/Group 307.svg" alt="Apply icon" class=""/><span class="icon_label">APPLY</span></div>
                      <!-- <button class="btn btn-earning" @click="applyPackage">Apply</button> -->
                      <!-- <button class="btn btn-earning" @click="applyToExistingEarning">Add to Earnings</button> -->
                    </div>
                    
                  </div>
                </div>
              </div>
            </div>
          </div>
          
        </div>
      </div>
    </div>

    

  </div>
</template>
<script>
import axios from "axios";
import { mapGetters } from 'vuex'
export default {
  props:["employeeId"],
  data() {
    return {     
      dates:[],
      dates2:[],
      basis: ["Daily", "Hourly", "Monthly"],
      displaySide: false,
      earning: {
        "type": "Basic",
        "startDate": "2019-07-03",
        "endDate": "2019-07-03",
        "frequency": "Daily",
        "basis": "Monthly",
        "rate": 0
      },
      earnings: [],
      allEarnings: [],
      frequencies: ["Daily", "Weekly", "Monthly", "Fortnightly"],
      packages: [],
      types: ["Basic", "Housing", "Transport", "Meal", "Utilities", "Leave", "Dressing", "Entertainment", "Telephone", "Car", "Benefit" ],
      deductionTypes: ["Tax", "NHF", "HMO", "Pension", "C.R.A", "Loans"],
      grossPay: "",
      tax: "",
      pension: "",
      hmo: 32630,
      nhf: "",
      cra: "",
      totalDeduction: null,
      employeePackages: [],
      useTemplate: true,
      addTemplate: false,
      showPackage: false,
      currentTab: true,
      deductionTab: false,
      package_id: "",
      packageEarnings:[],
      t_earnings: false,
      checked: "",
      startDate: "",
      endDate: "",
      deduction: {
        "type": "Tax",
        "startDate": "2019-08-03",
        "endDate": "2019-08-03",
        "frequency": "Monthly",
        "basis": "Monthly",
        "rate": 0
      },
      deductions: [],
      alertSuccess: false,
      historyTab: false
    }
  },
  computed: {
    earningsExist() {
      return this.earnings != null && this.earnings.length > 0
    },
    ...mapGetters([
      'saved_package_alert'
    ])
  },
  methods: {
    currentEarning() {
      this.currentTab = true
      this.historyTab = false
    },
    historyEarning() {
      this.currentTab = false
      this.historyTab = true
    },
    addItem(index) {
      this.earnings[index].type = this.earning.type
      // this.earnings[index].startDate = this.earning.startDate
      // this.earnings[index].endDate = this.earning.endDate
      this.earnings[index].startDate = this.dates[0]
       this.earnings[index].endDate = this.dates[1]
      this.earnings[index].frequency = this.earning.frequency
      this.earnings[index].basis = this.earning.basis
      this.earnings[index].rate = this.earning.rate
      this.earnings[index].is_editable = false
      console.log("this.earning.startDate")
      console.log(this.value)
      
      this.resetEarning()
    },
    addDeductionItem(index) {
      this.deductions[index].type = this.deduction.type
      this.deductions[index].startDate = this.deduction.startDate
      this.deductions[index].endDate = this.deduction.endDate
      this.deductions[index].frequency = this.deduction.frequency
      this.deductions[index].basis = this.deduction.basis
      this.deductions[index].rate = this.deduction.rate
      this.deductions[index].is_editable = false
    },
    addRow() {
      this.earnings.push({
        "type": "Basic",
        "startDate": "2019-05-03",
        "endDate": "2019-06-03",
        "frequency": "Daily",
        "basis": "Monthly",
        "rate": 0,
        "is_editable": true
      })
    },
    addDeductionRow() {
      this.deductions.push({
        "type": "Tax",
        "startDate": "2019-08-01",
        "endDate": "2019-09-01",
        "frequency": "Monthly",
        "basis": "Monthly",
        "rate": 0,
        "is_editable": true
      })
    },
    addType(event) {
      console.log(event.target.value)
    },
    cancelItem(index) {
      this.$set(this.earnings[index], 'is_editable', false)
    },
    cancelDeductionItem(index) {
      this.$set(this.deductions[index], 'is_editable', false)
    },
    deleteRow(index) {
      // console.log(index)
      this.earnings.splice(index, 1)
      console.log(this.earnings)

    },
    editRow(index) {   
      this.$set(this.earnings[index], 'is_editable', true)
      this.earning.type = this.earnings[index].type,
      this.earning.startDate = this.earnings[index].startDate,
      this.earning.endDate = this.earnings[index].endDate,
      this.earning.frequency = this.earnings[index].frequency,
      this.earning.basis = this.earnings[index].basis,
      this.earning.rate = this.earnings[index].rate,
      this.dates = [this.earnings[index].startDate, this.earnings[index].endDate]
    },
    editDeductionRow(index) {
      this.$set(this.deductions[index], 'is_editable', true)
      this.deduction.type = this.deductions[index].type,
      this.deduction.startDate = this.deductions[index].startDate,
      this.deduction.endDate = this.deductions[index].endDate,
      this.deduction.frequency = this.deductions[index].frequency,
      this.deduction.basis = this.deductions[index].basis,
      this.deduction.rate = this.deductions[index].rate
    },
    getEarnings() {
      let self = this;
      axios.get(`/api/earnings/${this.employeeId}`)
      .then(function(response) {
        // console.log(response.data);
        self.earnings = [...response.data]
      })
      .catch(function(error) {
        console.log(error);
      });
    },
    formatNumber(number, signed=false) {
      let result = new Intl.NumberFormat().format(number)
      return (signed ? `- ₦ ${result}` : `₦ ${result}`)
    },
    resetEarning() {
      this.earning.type = "Salary",
      this.earning.startDate = "2019-05-03",
      this.earning.endDate = "2019-05-03",
      this.earning.frequency = "Daily",
      this.earning.basis = "Monthly",
      this.earning.rate = 0
    },
    resetDeduction() {
      this.deduction.type = "Salary",
      this.deduction.startDate = "2019-05-03",
      this.deduction.endDate = "2019-05-03",
      this.deduction.frequency = "Daily",
      this.deduction.basis = "Monthly",
      this.deduction.rate = 0
    },
    addPackageTemplate() {
      console.log(this.passedEarning)
      this.earnings = [...this.passedEarning]
    },
    savePackage() {
      var self = this;
      var url = '/api/earnings'
      let csrf = document.querySelector("meta[name='csrf-token']").getAttribute("content");
      const axios = require('axios');
      var params = {employee:this.employeeId, earning:this.earnings};
      axios.post( url, params, { headers: {'Content-Type': 'application/json', 'x-csrf-token': csrf}})
      .then((response)=>{
        // TODO: Add a response or flash
        console.log(typeof(response.data))
        var package_id = response.data
        this.deducationCalculation()
        this.alertSuccess = true
        setTimeout(function(){self.alertSuccess = false }, 5000);
        console.log("package id = " + package_id)
        var url2 = '/api/deduction'
        var paramss = [
          {"deduction":
            {
              "basis": "Monthly",
              "frequency": "Monthly",
              "rate": this.tax,
              "type": "Tax",
              "start_date": this.earnings[0].startDate,
              "end_date": this.earnings[0].endDate,
              "package_id": package_id
            }
          },
          {"deduction":
            {
              "basis": "Monthly",
              "frequency": "Monthly",
              "rate": this.pension,
              "type": "Pension",
              "start_date": this.earnings[0].startDate,
              "end_date": this.earnings[0].endDate,
              "package_id": package_id
            }
          },
          {"deduction":
            {
              "basis": "Monthly",
              "frequency": "Monthly",
              "rate": this.hmo/12,
              "type": "HMO",
              "start_date": this.earnings[0].startDate,
              "end_date": this.earnings[0].endDate,
              "package_id": package_id
            }
          },
          {"deduction":
            {
              "basis": "Monthly",
              "frequency": "Monthly",
              "rate": this.nhf,
              "type": "NHF",
              "start_date": this.earnings[0].startDate,
              "end_date": this.earnings[0].endDate,
              "package_id": package_id
            }
          }   
        ]
        
        
        for(var i = 0; i < paramss.length; i++) {
          axios.post( url2, paramss[i], { headers: {'Content-Type': 'application/json', 'x-csrf-token': csrf}})
          .then((response)=>{
            console.log("Everything works")
          })
        }
          
        this.$store.commit('toggle_saved_package_alert ', true)
      ;})

      

    },
    showPackages: function() {
      var self = this;
      axios
      .get("/api/list_packages")
      .then(function(response) {
        self.employeePackages = response.data.packages;
       })
        .catch(function(error) {
        });

      
      this.showPackage = !this.showPackage
    },
    getPackageDeductions() {
      axios.get("api/employeedeductions/" + this.employeeId)
        .then((response)=>{
          this.package_id = response.data.package


          axios.get("api/deductions/" + this.package_id)
          .then((response)=> {
            this.deductions = response.data.data
            console.log(response.data.data)

            // for(var i; i < this.deductions.length; i++) {
            //   this.deductions[i].start
            // }
          })
        })
    },
    getPackageEarnings() {
      var self = this;
      axios.get("/api/package_earnings/"+ this.package_id).then(function(response){
        self.packageEarnings = response.data
      })
      .catch(function (error) {
        console.log(error)
      })
      
      this.t_earnings = true
    },
    applyPackage: function() {
      for(let i = 0; i < this.packageEarnings.length; i++) {
        // this.packageEarnings[i].startDate = this.startDate
        // this.packageEarnings[i].endDate = this.endDate
        this.packageEarnings[i].startDate = this.dates2[0]
        this.packageEarnings[i].endDate = this.dates2[1]
      }
      console.log(this.packageEarnings)
      if(this.checked == false) {
        
          this.earnings = this.packageEarnings
          this.showPackage = true
      } else {
        if(this.earnings !== this.packageEarnings){
          this.earnings = [...this.earnings, ...this.packageEarnings]
        }
      }
    },
    closePackage: function() {
      this.showPackage = false;
      this.useTemplate = true
      this.addTemplate = false
    },
    current: function() {
      this.currentTab = true
      this.deductionTab = false
    },
    deductionView: function() {
      this.currentTab = false
      this.deductionTab = true

      this.deducationCalculation()
      this.getDeductions()
    },
    cancelEarning: function() {
      this.t_earnings = false
      this.showPackage = false
    },
    applyToExistingEarning: function() {
      this.earnings = [...this.earnings, ...this.packageEarnings]
    },
    deducationCalculation: function() {
      var grossPay = 0
      for (var i = 0; i < this.earnings.length; i++) {
        grossPay += parseFloat(this.earnings[i]["rate"])
      }
      this.grossPay = grossPay
      var annualGrossPay = grossPay * 12
      console.log("annual gross pay= " + annualGrossPay)

      let consolidated = 0
      let basic = 0
      for(var i = 0; i < this.earnings.length; i++){
        if (this.earnings[i].type === "Basic"){
          consolidated += parseFloat(this.earnings[i].rate)
          basic += parseFloat(this.earnings[i].rate)
        } else if(this.earnings[i].type === "Housing"){
          consolidated += parseFloat(this.earnings[i].rate)
        } else if(this.earnings[i].type === "Transport"){
          consolidated += parseFloat(this.earnings[i].rate)
        } else {
          consolidated += 0
        }
      }

      // console.log("consolidated= " + consolidated)
      // console.log("basic= " + basic)

      let pension = (0.08 * (consolidated))
      this.pension = pension.toFixed(2)
      // console.log("pension= " + pension)
      
      let nhf = parseFloat(0.025 * (basic))
      this.nhf = nhf
      // console.log("nhf= " + nhf)

      let taxArray = []
      let remainingTaxableIncome = 0

      var cra = 200000 + (0.2 * annualGrossPay)
      console.log(annualGrossPay + " " + cra)
      this.cra = cra.toFixed(2)
      // console.log("cra= " + cra)

      // let taxableIncome = annualGrossPay - parseFloat(this.hmo + (this.pension) + (this.nhf) + 34475)
      let taxableIncome = annualGrossPay - parseFloat(this.hmo + (pension*12) + (nhf*12) + cra)
      // console.log("Taxable Income= " + taxableIncome)

      if(taxableIncome > 300000) {
        taxArray[0] = (7/100) * 300000
        remainingTaxableIncome = taxableIncome - 300000
      } else {
        taxArray[0] = (1/100) * taxableIncome
      }
      if(remainingTaxableIncome > 300000) {
        taxArray[1] = (11/100) * 300000
        remainingTaxableIncome = remainingTaxableIncome - 300000
      } else {
        taxArray[1] = (11/100) * remainingTaxableIncome
        remainingTaxableIncome = 0
      }
      if(remainingTaxableIncome > 500000) {
        taxArray[2] = (15/100) * 500000
        remainingTaxableIncome = remainingTaxableIncome - 500000
      } else {
        taxArray[2] = (15/100) * remainingTaxableIncome
        remainingTaxableIncome = 0
      }
      if(remainingTaxableIncome > 500000) {
        taxArray[3] = (19/100) * 500000
        remainingTaxableIncome = remainingTaxableIncome - 500000
      } else {
        taxArray[3] = (19/100) * remainingTaxableIncome
        remainingTaxableIncome = 0
      }
      if(remainingTaxableIncome > 1600000) {
        taxArray[4] = (21/100) * 1600000
        remainingTaxableIncome = remainingTaxableIncome - 1600000
      } else {
        taxArray[4] = (21/100) * remainingTaxableIncome
        remainingTaxableIncome = 0
      }
      if(taxableIncome > 3200000 ) {
        taxArray[5] = (24/100) * remainingTaxableIncome
        remainingTaxableIncome = remainingTaxableIncome - 3200000
      }
      

      const add = (a, b) => a + b
      const annualTax = taxArray.reduce(add)
      var monthlyTax = annualTax /12

      
      this.tax = monthlyTax.toFixed(2)

    //   var totalDeduction = monthlyTax + (this.hmo/12) + (nhf/12) + (pension/12)
    //   this.totalDeduction = totalDeduction
    },
    getDeductions: function() {
      this.deducationCalculation()
      this.deductions =
        [{
          "basis": "Monthly",
          "frequency": "Monthly",
          "rate": this.tax,
          "type": "Tax",
          "start_date": this.earnings[0].startDate,
          "end_date": this.earnings[0].endDate
        },
        {
          "basis": "Monthly",
          "frequency": "Monthly",
          "rate": this.pension,
          "type": "Pension",
          "start_date": this.earnings[0].startDate,
          "end_date": this.earnings[0].endDate
        },
        {
          "basis": "Monthly",
          "frequency": "Monthly",
          "rate": (this.hmo/12).toFixed(2),
          "type": "HMO",
          "start_date": this.earnings[0].startDate,
          "end_date": this.earnings[0].endDate
        },
        {
          "basis": "Monthly",
          "frequency": "Monthly",
          "rate": this.nhf,
          "type": "NHF",
          "start_date": this.earnings[0].startDate,
          "end_date": this.earnings[0].endDate
        }
        // {
        //   "basis": "Monthly",
        //   "frequency": "Monthly",
        //   "rate": this.cra,
        //   "type": "CRA",
        //   "start_date": this.earnings[0].startDate,
        //   "end_date": this.earnings[0].endDate
        // }
      ]
    },
    getAllEarnings: function() {
      axios.get('api/earnings/employee/' + this.employeeId)
      .then((response)=>{
        console.log(response.data[0].earnings)
        for (var i = 0; i < response.data.length; i++) {
          for(var k = 0; k < response.data[i].earnings.length; k++) {
            this.allEarnings.push(response.data[i].earnings[k])
          }
        }
      })
    }
  },
  mounted() {
    this.getAllEarnings()
    this.getEarnings()
    // this.getPackageDeductions()
  }
}
</script>
<style scoped>
  input[type=date]::-webkit-inner-spin-button {
    -webkit-appearance: none;
    display: none;
    }
  input[type=date]::-webkit-calendar-picker-indicator { 
    -webkit-appearance:block;
    color: transparent; 
    background-color: transparent; 
    width:80%; 
    height:20px;
    position: absolute;
    }
  input[type="date"]::-webkit-clear-button { 
    display: none;
    }
  input[type="date"]::-webkit-clear-button { 
    display: none;
    }
  input[type="date"]::-ms-clear { 
    display: none;
    }
  select {
    /* for Firefox */
    -moz-appearance: none;
    /* for Chrome */
    -webkit-appearance: none;
    text-indent: 1px;
    text-overflow: '';
  }

  /* For IE10 */
  select::-ms-expand {
    display: none;
  }

  .custom-form-select{
    /* height: 100%;
    line-height: 1.2rem;
    outline: 0;
    // padding: .25rem .4rem; 
    padding: 1px !important;
    vertical-align: middle;
    border: 1px #c4cdd5 solid !important; */
    background-color: aliceblue;
    border-radius: 0;
    border: none;
    height: 1rem !important;
    border-bottom: 1px solid #2196f3;
      
  }
  .date_context{ 
    position: relative;}
  .form-input{
    padding: 0px !important;
    /* height:100%;  */
    background-color: aliceblue; 
    border-radius: 0; 
    border: 0px !important;
    height: 1rem !important;
    border-bottom: 1px solid #2196f3 !important;
    }
  input[type=number]::-webkit-inner-spin-button {
    -webkit-appearance: none;  
    display: none; 
    height:35px !important}
  /* input[type=date]{
    width: 80%
    } */
  input[type=number]{
    padding:5px 0px !important;
    }
  .custom-form-select:not([multiple]):not([size]) {
    padding: 0px !important
    }
  td{
    width: 3.5rem ;
    }
    .input-group .form-select {
      width: 100% !important;
    }
    .space1 {
      margin-left: -1.2rem;
    }
    .space-1 {
      margin-left: -0.5rem;
    }
    .content {
      margin-left: 0 !important;
      margin-right: 10px !important;
    }
    .modal-body {
      padding-left: 10px !important;
      overflow-y: scroll;
    }
    .startDate {
      border: .05rem solid #bcc3ce !important;
      padding: 5px 5px !important;
      width: 100% !important;
      height: 25px;
    }
    .endDate {
      border: .05rem solid #bcc3ce !important;
      padding: 5px 5px !important;
      width: 100% !important;
      height: 25px;
    }
    
    .space14 {
      margin-bottom: 14px;
    }
    .deduction {
      margin-left: 0.45rem;
      margin-right: 0.5rem;
    }
    .space045 {
      margin-left: 0.4rem;
    }
   #inline_datepicker .el-input__inner{
    height: 22px !important;
    border: 0px;
    border-bottom: 1px solid #2196f3;
    border-radius:0px
  }

   #inline_datepicker2 .el-input__inner{
    height: 26px !important;
    width: 100%;
    height: 1.4rem;
    /* border: 0px; */
    border: 1px solid #c4cdd5 ; 
    border-radius:0px;
    margin: 2px 0px 15px
  }

</style>
